package ar.com.fdvs.dj.test.groups;

import java.util.Map;

import org.apache.log4j.Logger;

import net.sf.jasperreports.engine.JRScriptletException;
import net.sf.jasperreports.engine.fill.JRFillVariable;
import ar.com.fdvs.dj.core.DJDefaultScriptlet;

/**
 * It is very important to extend {@link DJDefaultScriptlet} because it is needed for the normal operation of the Report.
 * @author mamana
 *
 */
public class MyDjScriptlet extends DJDefaultScriptlet {
	/**
	 * Logger for this class
	 */
	private static final Logger logger = Logger.getLogger(MyDjScriptlet.class);
	private Map precalculatedValues;

	public void afterGroupInit(String groupName) throws JRScriptletException {		
		super.afterGroupInit(groupName);
		
		String currentGroupValue = (String) getFieldValue("state");
		
		logger.debug("afterGroupInit [" + groupName + "] = " + currentGroupValue);
		
		/**
		 * Recover JasperReport variable (the holder for the calculated value)
		 * The naming convention used in DJ is: variable-<[header|footer]>_<grouped column property>_<column with the variable>
		 * As an example: variable-header_state_quantity stands for: a header variable placed in the group for the column "state" 
		 * which calculates in the column "quantity"
		 */
		JRFillVariable var = (JRFillVariable) variablesMap.get("variable-header_state_quantity");
		
		/**
		 * Here We get the precalculated value for the current group
		 */
		Object precalculatedValue = getPrecalculatedValue("state", currentGroupValue);
		
		var.setValue(precalculatedValue);
		
	}

	private Object getPrecalculatedValue(String fieldName, String currentValue) {
		return precalculatedValues.get(currentValue);
	}

	public void setPrecalculatedValues(Map precalculateValues) {
		this.precalculatedValues = precalculateValues;
		
	}

}
